#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "Graphics.h"

#define width 900
#define height 768


static unsigned int m_z=12345,m_w=45678;

#define robotX 50
#define robotY 50
#define MAXDIST 500
#define laserAngleMin = 30
#define laserAngleMax = (180-30)

#define TIME 2000

char gridWorld[][90]={
    "                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         ",
	"                                                                                         "
};

char maze[][90]={
	"#########################################################################################",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"##     ###########                          #                                           #",
	"#      #         #                          #                                           #",
	"#      #         #                          #                                           #",
	"#      ###########                          #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                                                                       #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#                                           #                                           #",
	"#########################################################################################"
};

bool isBumped(int x, int y){

	int xx,yy;
	for (double t=0; t<10; t+=0.01){
		xx = (x+(int)(22*sin(t)))/10;
		yy = (y+(int)(22*cos(t)))/10;
		if (maze[yy][xx]!=' '){
			return true;
		}
	}
	return false;
}

int main(int argc, char** argv)
{
	int tracex[TIME];
	int tracey[TIME];
	double deltaANGLE = 10;
	int scanAngle = 90;

	int turnMem=0;
	double laserMin = 30;
	double laserMax = 180-30;
    openWindow((char*)"Magic Robot Sim",width,height);
	double scanArray[1000];
	double scanArrayOld[1000];

	int xRob = robotY, yRob = robotX;
	int xRobOld, yRobOld;

	double robotVel=5;
	double robotAngleVel=0;

	double robotAngle = 90;

	int maxRays=0;


	// first layer

    for (int simStep=0;simStep<TIME;simStep++){

		// --- drawMaze
		for (int y=0;y<60;y++){
			for (int x=0;x<90;x++){
				setColor(0,0,0);
				drawBox(x*10,y*10,x*10+10,y*10+10);
				if (maze[y][x]==' '){
					setColor(0,0,0);
				}else{
					setColor(0,0,255);
				}
				drawBox(x*10,y*10,x*10+8,y*10+8);

				// ---- generated maze ---------

				if (gridWorld[y][x]==' '){
					setColor(0,0,0);
				}else{
					setColor(0,255,255);
				}
				drawBox(x*2,600+y*2,x*2+1,600+y*2+1);



			}
		}
		tracex[simStep] = xRob;
		tracey[simStep] = yRob;
		setColor(127,127,127);
		for (int t=0;t<simStep;t++){
			drawLine(tracex[t],tracey[t],tracex[t+1],tracey[t+1]);
		}
		setColor(255,255,255);
		// ----- This is the Robots program

		// xRob,yRob are from GPS sensor
		// robotAngle is from compass sensor

		for ( int t=0;t<maxRays;t++){

			double angle = (robotAngle-60) + t*deltaANGLE;

			int xx = (xRob+(int)(scanArray[t]*sin(angle/180.0*3.1415)))/10;
			int yy = (yRob+(int)(scanArray[t]*cos(angle/180.0*3.1415)))/10;
			if (scanArray[t]<MAXDIST-0.5){
				gridWorld[yy%60][xx%90] = '*';
			}

		}


		if (turnMem == 0){
			robotAngleVel = 0;

			if (scanArray[maxRays/5]<40){
				robotAngleVel = 5;			// turn right
				turnMem=25;
			}
			if (scanArray[maxRays-maxRays/5]<40){
				robotAngleVel = -5;			// turn left
				turnMem=25;
			}

		}
		else{
			turnMem--;
		}

		// ----------------------------------------------------

		robotAngle += robotAngleVel;

		xRob = xRob + robotVel*sin(robotAngle/180.0*3.1415);
		yRob = yRob + robotVel*cos(robotAngle/180.0*3.1415);

		laserMin = robotAngle - 60;
		laserMax = robotAngle + 60;

		if (isBumped(xRob, yRob)){
			xRob = xRobOld;
			yRob = yRobOld;
		}
		else{
			xRobOld = xRob;
			yRobOld = yRob;
		}


		// --- draw Robot
		drawCircle(xRob,yRob,20);
		setColor(255,0,0);
		maxRays=0;
		for (double angle = laserMin; angle<laserMax; angle+=deltaANGLE){
			for (double dist=20;dist<MAXDIST;dist+=0.5){
					setPixel(xRob+(int)(dist*sin(angle/180.0*3.1415)), yRob+(int)(dist*cos(angle/180.0*3.1415)));
					int xx = (xRob+(int)(dist*sin(angle/180.0*3.1415)))/10;
					int yy = (yRob+(int)(dist*cos(angle/180.0*3.1415)))/10;

					scanArray[maxRays%1000] = dist; // measure Laserscan Data

					if (maze[yy][xx]!=' '){
						break;
					}
			}
			maxRays++;
		}

		int msec = 0;
		clock_t before = clock();
		do {
		  clock_t difference = clock() - before;
		  msec = difference * 1000 / CLOCKS_PER_SEC;
		} while ( msec < 10 ); // wait 10 ms
		//display();

	}


}
